using System;
using System.Windows.Media; 
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Styx;
using Styx.Common.Helpers;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Common;
using Styx.Plugins;

namespace FishingPoleHatLures 
{
    public class FishingPoleHatLuresPlugin : HBPlugin 
	{
		
        public override string Name {
            get { return "Fishing Pole And Hat Lures"; }
        }

        public override string Author {
            get { return "Proto"; }
        }

        public override Version Version {
            get { return new Version(1, 0); }
        }

        public override void OnEnable() {
            Logging.Write(Colors.Orange, "[Plugin] Fishing Pole And Hat Lures:  Enabled");
            
            base.OnEnable();
        }

        public override void OnDisable() {
            Logging.Write(Colors.OrangeRed, "[Plugin] Fishing Pole And Hat Lures:  Disabled");

            base.OnDisable();
        }
	
		public readonly static WaitTimer LureRecastTimer = WaitTimer.TenSeconds;
		
		public override void Pulse() 
		{
			if (StyxWoW.Me.IsMoving || StyxWoW.Me.Combat || IsLureOnPole || !StyxWoW.Me.HasAura(131490) || !LureRecastTimer.IsFinished) 
				return;
			
			LureRecastTimer.Reset();
			var mainHand = StyxWoW.Me.Inventory.Equipped.MainHand;

			if (mainHand == null || mainHand.ItemInfo.WeaponClass != WoWItemWeaponClass.FishingPole)
				return;

            WoWItem mainwapon = StyxWoW.Me.Inventory.Equipped.MainHand;
            if (mainwapon != null && mainwapon.HasEquipCooldown && mainwapon.CooldownTimeLeft <= System.TimeSpan.Zero)
            {
            // Use Fishing Pole lure
				Logging.Write(Colors.Orange, "[Plugin] Fishing Pole And Hat Lures:  Using Fishing Pole lure");
                mainwapon.Use();
                CommonCoroutines.SleepForLagDuration();
                return;
            }

			WoWItem head = StyxWoW.Me.Inventory.Equipped.Head;
            if (head != null && head.HasEquipCooldown && head.CooldownTimeLeft <= System.TimeSpan.Zero)
            {
            // Use Fishing Hat lure
				Logging.Write(Colors.Orange, "[Plugin] Fishing Pole And Hat Lures:  Using Fishing Hat lure");
                head.Use();
                CommonCoroutines.SleepForLagDuration();
                return;
            }
			
			return;
		}

		public static bool IsLureOnPole
		{
			get
			{
				bool useHatLure = false;

				var head = StyxWoW.Me.Inventory.GetItemBySlot((uint)WoWEquipSlot.Head);
				if (head != null)
					useHatLure = true;

				var ret = Lua.GetReturnValues("return GetWeaponEnchantInfo()");
				return ret != null && ret.Count > 0 && ret[0] == "1";
			}
		}
	}
}
